local function create_scaled_atomic_rocket(scale)
    local atomic_rocket = table.deepcopy(data.raw.projectile["atomic-rocket"])
    atomic_rocket.name = "JGB-" .. tostring(scale)
    atomic_rocket.acceleration = 0
    atomic_rocket.turning_speed_increases_exponentially_with_projectile_speed = false

    scale = scale / 100

    local target_effects = atomic_rocket.action.action_delivery.target_effects
    target_effects[1].radius = target_effects[1].radius * scale
    target_effects[2].radius = target_effects[2].radius * scale
    target_effects[4].duration = math.min(255, target_effects[4].duration * scale)
    target_effects[4].ease_in_duration = math.min(255, target_effects[4].ease_in_duration * scale)
    target_effects[4].ease_out_duration = math.min(255, target_effects[4].ease_out_duration * scale)
    target_effects[4].full_strength_max_distance = target_effects[4].full_strength_max_distance * scale
    target_effects[4].max_distance = target_effects[4].max_distance * scale
    target_effects[4].strength = target_effects[4].strength * scale
    target_effects[5].max_distance = target_effects[5].max_distance * scale
    target_effects[6].max_distance = target_effects[6].max_distance * scale
    target_effects[7].damage.amount = target_effects[7].damage.amount * scale

    if scale < 0.03 then
        target_effects[8].entity_name = "small-scorchmark"
    elseif scale < 0.1 then
        target_effects[8].entity_name = "medium-scorchmark"
    end

    target_effects[10].radius = target_effects[10].radius * scale
    target_effects[11].spawn_max = target_effects[11].spawn_max * scale
    target_effects[11].spawn_max_radius = math.min(24, target_effects[11].spawn_max_radius * scale)
    target_effects[11].spawn_min = target_effects[11].spawn_min * scale
    target_effects[11].spawn_min_radius = target_effects[11].spawn_min_radius * scale
    target_effects[12].action.radius = target_effects[12].action.radius * scale
    target_effects[12].action.repeat_count = target_effects[12].action.repeat_count * scale
    target_effects[13].action.radius = target_effects[13].action.radius * scale
    target_effects[13].action.repeat_count = target_effects[13].action.repeat_count * scale
    target_effects[14].action.radius = target_effects[14].action.radius * scale
    target_effects[14].action.repeat_count = target_effects[14].action.repeat_count * scale
    target_effects[15].action.radius = target_effects[15].action.radius * scale
    target_effects[15].action.repeat_count = target_effects[15].action.repeat_count * scale
    target_effects[16].action.radius = target_effects[16].action.radius * scale
    target_effects[16].action.repeat_count = target_effects[16].action.repeat_count * scale
    target_effects[17].action.radius = target_effects[17].action.radius * scale
    target_effects[17].action.repeat_count = target_effects[17].action.repeat_count * scale
    target_effects[18].action.radius = target_effects[18].action.radius * scale
    target_effects[18].action.repeat_count = target_effects[18].action.repeat_count * scale

    data:extend({atomic_rocket})
end

for i = 1, 8000 do
    create_scaled_atomic_rocket(i)
end
